<?php

namespace app\models\mikrotik\wireless;

use yii\base\Model;
use Yii;

require_once 'PEAR2_Net_RouterOS-1.0.0b5.phar';

use PEAR2\Net\RouterOS;
use app\models\mikrotik\MikrotikConnect;

class Channels extends Model {

    public $id;
    public $list;
    public $name;
    public $frequency = '2412';
    public $width = '20';
    public $band;
    public $extension_channel;
    public $disabled;

    public function rules() {
        return [
            ['id', 'string'],
            ['list', 'string'],
            ['name', 'string'],
            ['frequency', 'string'],
            ['width', 'string'],
            ['band', 'string'],
            ['extension_channel', 'string'],
            ['disabled', 'string'],
        ];
    }

    public function getAll() {
        $connect = MikrotikConnect::Instance();
        $getRequest = new RouterOS\Request('/interface/wireless/channels/getall');
        $responses = $connect->getConnection()->sendSync($getRequest);
        $return = array();
        foreach ($responses as $response) {
            if ($response->getProperty('.id') != null) {
                $c = new Channels();
                $c->id = $response->getProperty('.id');
                $c->list = $response->getProperty('list');
                $c->name = $response->getProperty('name');
                $c->frequency = $response->getProperty('frequency');
                $c->width = $response->getProperty('width');
                $c->band = $response->getProperty('band');
                $c->extension_channel = $response->getProperty('extension-channel');
                $c->disabled = $response->getProperty('disabled');
                $return[] = $c;
            }
        }
        return $return;
    }

    public function get($id) {
        $connect = MikrotikConnect::Instance();
        $getRequest = new RouterOS\Request('/interface/wireless/channels/print');
        $getRequest->setQuery(RouterOS\Query::where('.id', $id));
        $responses = $connect->getConnection()->sendSync($getRequest);
        foreach ($responses as $response) {
            if ($response->getProperty('.id') != null) {
                $this->id = $response->getProperty('.id');
                $this->list = $response->getProperty('list');
                $this->name = $response->getProperty('name');
                $this->frequency = $response->getProperty('frequency');
                $this->width = $response->getProperty('width');
                $this->band = $response->getProperty('band');
                $this->extension_channel = $response->getProperty('extension-channel');
                $this->disabled = (($response->getProperty('disabled') == 'true') ? true : false);
            }
        }
        return;
    }

    public function update($id) {
        $c = new Channels();
        $c->get($id);
        $connect = MikrotikConnect::Instance();
        $setRequest = new RouterOS\Request('/interface/wireless/channels/set');
        $setRequest->setargument('.id', $id);
        if ($this->list != $c->list) {
            $setRequest->setargument('list', $this->list);
        }
        if ($this->name != $c->name) {
            $setRequest->setargument('name', $this->name);
        }
        if ($this->frequency != $c->frequency) {
            $setRequest->setargument('frequency', $this->frequency);
        }
        if ($this->width != $c->width) {
            $setRequest->setargument('width', $this->width);
        }
        if ($this->band != $c->band) {
            $setRequest->setargument('band', $this->band);
        }
        if ($this->extension_channel != $c->extension_channel) {
            $setRequest->setargument('extension-channel', $this->extension_channel);
        }
        if (isset($unset)) {
            $unsetRequest = new RouterOS\Request('/interface/wireless/channels/unset');
            foreach ($unset as $value) {
                $unsetRequest->setArgument('.id', $id);
                $unsetRequest->setArgument('value-name', $value);
                $resp = $connect->getConnection()->sendSync($unsetRequest);
                if ($resp->getType() !== RouterOS\Response::TYPE_FINAL) {
                    if (!isset($re)) {
                        $re = '';
                    } $re.= ' ' . $resp->getProperty('message');
                }
            }
        } $resp = $connect->getConnection()->sendSync($setRequest);
        if ($resp->getType() !== RouterOS\Response::TYPE_FINAL) {
            if (isset($re)) {
                $re.= ' ' . $resp->getProperty('message');
            } else {
                $re = $resp->getProperty('message');
            }
        } if (isset($re)) {
            return $re;
        } else {
            return '1';
        }
    }

    public function disable($id) {
        $connect = MikrotikConnect::Instance();
        $setRequest = new RouterOS\Request('/interface/wireless/channels/disable');
        $setRequest->setArgument('.id', $id);
        $connect->getConnection()->sendSync($setRequest);
        return;
    }

    public function enable($id) {
        $connect = MikrotikConnect::Instance();
        $setRequest = new RouterOS\Request('/interface/wireless/channels/enable');
        $setRequest->setArgument('.id', $id);
        $connect->getConnection()->sendSync($setRequest);
        return;
    }

    public function create() {
        $connect = MikrotikConnect::Instance();
        $setRequest = new RouterOS\Request('/interface/wireless/channels/add');
        if ($this->list != "") {
            $setRequest->setargument('list', $this->list);
        }
        if ($this->name != "") {
            $setRequest->setargument('name', $this->name);
        }
        if ($this->frequency != "") {
            $setRequest->setargument('frequency', $this->frequency);
        }
        if ($this->width != "") {
            $setRequest->setargument('width', $this->width);
        }
        if ($this->band != "") {
            $setRequest->setargument('band', $this->band);
        }
        if ($this->extension_channel != "") {
            $setRequest->setargument('extension-channel', $this->extension_channel);
        }
        $resp = $connect->getConnection()->sendSync($setRequest);
        if ($resp->getType() !== RouterOS\Response::TYPE_FINAL) {
            return $resp->getProperty('message');
        } else {
            return '1';
        }
    }

    public function delete($id) {
        $connect = MikrotikConnect::Instance();
        $util = new RouterOS\Util($connect->getConnection());
        $util->setMenu('/interface/wireless/channels');
        $util->remove(RouterOS\Query::where('.id', $id));
        return;
    }

}
